/*
 * Created on 18-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspect.ajdt.internal.core;

import java.util.ArrayList;
import java.util.StringTokenizer;

import org.aspectj.ajdt.core.IAjType;
import org.aspectj.ajdt.core.IAspectJElement;
import org.aspectj.ajdt.core.IPointcut;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.IType;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.Signature;
import org.eclipse.jdt.core.WorkingCopyOwner;
import org.eclipse.jdt.internal.core.JavaElement;
import org.eclipse.jdt.internal.core.SourceType;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class AjSourceType extends SourceType implements IAjType {

	/**
	 * @param parent
	 * @param name
	 */
	public AjSourceType(JavaElement parent, String name) {
		super(parent, name);
	}

	/* (non-Javadoc)
	 * @see org.aspectj.ajdt.core.IAjType#isAspect()
	 */
	public boolean isAspect() throws JavaModelException{
		AjSourceTypeElementInfo info = (AjSourceTypeElementInfo) getElementInfo();
		return info.isAspect();		
	}
	
	public boolean isClass() throws JavaModelException {
		AjSourceTypeElementInfo info = (AjSourceTypeElementInfo) getElementInfo();
		return info.isClass();		
	}

	public IType getType(String typeName) {
		return new AjSourceType(this, typeName);
	}

	/* (non-Javadoc)
	 * @see org.aspectj.ajdt.core.IAjType#getPointcuts()
	 */
	public IPointcut[] getPointcuts() throws JavaModelException {
		ArrayList list = getChildrenOfType(IAspectJElement.POINTCUT);
		IPointcut[] array= new IPointcut[list.size()];
		list.toArray(array);
		return array;
	}
	
	
	/* (non-Javadoc)
	 * @see org.eclipse.jdt.internal.core.JavaElement#getHandleFromMemento(java.lang.String, java.util.StringTokenizer, org.eclipse.jdt.core.WorkingCopyOwner)
	 */
	public IJavaElement getHandleFromMemento(
		String token,
		StringTokenizer memento,
		WorkingCopyOwner workingCopyOwner) {
		IJavaElement ret = super.getHandleFromMemento(token, memento, workingCopyOwner);
		if (ret == null) {
			// it must be an aspectj element
			switch (token.charAt(0)) {
			case AspectJElement.AJEM_ADVICE:
				String selector = memento.nextToken();
				ArrayList params = new ArrayList();
				nextParam: while (memento.hasMoreTokens()) {
					token = memento.nextToken();
					switch (token.charAt(0)) {
					case JEM_TYPE:
						break nextParam;
					case JEM_METHOD:
						String param = memento.nextToken();
						StringBuffer buffer = new StringBuffer();
						while (Signature.C_ARRAY == param.charAt(0)) {
							buffer.append(Signature.C_ARRAY);
							param = memento.nextToken();
						}
						params.add(buffer.toString() + param);
						break;
					default:
						break nextParam;
					}
				}
				String[] parameters = new String[params.size()];
				params.toArray(parameters);
				JavaElement advice = (JavaElement)getAdvice(selector, parameters);
				if (token != null) {
					switch (token.charAt(0)) {
					case JEM_TYPE:
					case JEM_LOCALVARIABLE:
						return advice.getHandleFromMemento(token, memento, workingCopyOwner);
					default:
						return advice;
					}
				} else {
					return advice;
				}
			case AspectJElement.AJEM_DEOW:
				JavaElement deow = (JavaElement)getDeclareErrorOrWarning();
				return deow.getHandleFromMemento(memento, workingCopyOwner);
				
			// TODO other handle cases...
			}				
		}
		return ret;
	}

	/**
	 * @param id
	 * @return
	 */
	private JavaElement getDeclareErrorOrWarning() {
		return new SourceDeclareErrorOrWarning(this);
	}

	/**
	 * @param adviceCount
	 * @return
	 */
	private JavaElement getAdvice(String adviceName, String[] params) {
		return new SourceAdvice(this,adviceName,params);
	}

}
