/*
 * Created on 19-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspect.ajdt.internal.core;

import java.util.StringTokenizer;

import org.aspectj.ajdt.core.IAspectJElement;
import org.aspectj.ajdt.core.IDeclareErrorOrWarning;
import org.aspectj.ajdt.core.jdom.IAjDOMNode;
import org.aspectj.ajdt.core.jdom.IDOMDeclareErrorOrWarning;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.WorkingCopyOwner;
import org.eclipse.jdt.core.jdom.IDOMNode;
import org.eclipse.jdt.internal.core.JavaElement;
import org.eclipse.jdt.internal.core.Member;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SourceDeclareErrorOrWarning
	extends Member
	implements IDeclareErrorOrWarning {

	protected boolean isError;
	protected int pointcutHash;
	protected int messageHash;
	
	/**
	 * @param parent
	 * @param name
	 */
	public SourceDeclareErrorOrWarning(JavaElement parent, boolean isError, char[] pointcut, char[] message) {
		super(parent, "deow");
		this.isError = isError;
		this.pointcutHash = new String(pointcut).hashCode(); 
		this.messageHash = new String(message).hashCode();
	}

	protected SourceDeclareErrorOrWarning(JavaElement parent) {
		super(parent,"deow");
		// must call getHandleFromMemento if using this constructor
	}
	
	/* (non-Javadoc)
	 * @see org.aspectj.ajdt.core.IDeclareErrorOrWarning#isError()
	 */
	public boolean isError() {
		return isError;
	}

	/* (non-Javadoc)
	 * @see org.aspectj.ajdt.core.IDeclareErrorOrWarning#getPointcut()
	 */
	public String getPointcut()  throws JavaModelException {
		SourceDeclareErrorOrWarningElementInfo info = (SourceDeclareErrorOrWarningElementInfo) getElementInfo();
		return new String(info.getPointcut());
	}

	/* (non-Javadoc)
	 * @see org.aspectj.ajdt.core.IDeclareErrorOrWarning#getMessage()
	 */
	public String getMessage() throws JavaModelException {
		SourceDeclareErrorOrWarningElementInfo info = (SourceDeclareErrorOrWarningElementInfo) getElementInfo();
		return new String(info.getMessage());
	}
	
	public boolean equals(Object o) {
		if (!(o instanceof SourceDeclareErrorOrWarning)) return false;
		return super.equals(o) && membersMatch((SourceDeclareErrorOrWarning)o);
	}
	/**
	 * @param warning
	 * @return
	 */
	private boolean membersMatch(SourceDeclareErrorOrWarning warning) {
			return ((warning.isError == isError) &&
					(warning.pointcutHash == pointcutHash) &&
					(warning.messageHash == messageHash));
	}

	/**
	 * @see JavaElement#equalsDOMNode
	 */
	protected boolean equalsDOMNode(IDOMNode node) {
		if (node.getNodeType() == IAjDOMNode.DEOW) {
			IDOMDeclareErrorOrWarning d = (IDOMDeclareErrorOrWarning)node;
			return super.equalsDOMNode(node) && membersMatch(d);
		} else {
			return false;
		}
	}
	/**
	 * @param d
	 * @return
	 */
	private boolean membersMatch(IDOMDeclareErrorOrWarning d) {
			return ((d.isError() == isError()) &&
					(d.getPointcut().hashCode()  == pointcutHash) &&
					(d.getMessage().hashCode() == messageHash));
	}

	/**
	 * @see IJavaElement
	 */
	public int getElementType() {
		return IAspectJElement.DECLARE_ERROR_OR_WARNING;
	}
	
	/**
	 * @see JavaElement#getHandleMemento()
	 */
	public String getHandleMemento() {
		StringBuffer buff = new StringBuffer(((JavaElement) getParent()).getHandleMemento());
		buff.append(getHandleMementoDelimiter());
		buff.append(isError);
		buff.append(getHandleMementoDelimiter());
		buff.append(pointcutHash);
		buff.append(getHandleMementoDelimiter());
		buff.append(messageHash);
		if (this.occurrenceCount > 1) {
			buff.append(JEM_COUNT);
			buff.append(this.occurrenceCount);
		}
		return buff.toString();
	}
	/**
	 * @see JavaElement#getHandleMemento()
	 */
	protected char getHandleMementoDelimiter() {
		return AspectJElement.AJEM_DEOW;
	}


	/* (non-Javadoc)
	 * @see org.eclipse.jdt.internal.core.JavaElement#getHandleFromMemento(java.lang.String, java.util.StringTokenizer, org.eclipse.jdt.core.WorkingCopyOwner)
	 */
	public IJavaElement getHandleFromMemento(
		StringTokenizer memento,
		WorkingCopyOwner workingCopyOwner) {
		if (memento.countTokens() < 3) return this;
		isError = Boolean.valueOf(memento.nextToken()).booleanValue();
		memento.nextToken(); // delim
		pointcutHash = Integer.valueOf(memento.nextToken()).intValue();
		memento.nextToken(); // delim
		messageHash = Integer.valueOf(memento.nextToken()).intValue();		
		return this;
	}

}
