/*
 * Created on 22-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspectj.ajdt.core.xref;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.aspectj.ajdt.internal.core.builder.AjBatchImageBuilder;
import org.eclipse.contribution.xref.core.IXReference;
import org.eclipse.contribution.xref.core.IXReferenceProvider;
import org.eclipse.jdt.core.IJavaElement;
import org.eclipse.jdt.core.JavaCore;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class XRefProvider implements IXReferenceProvider {

	private static final Class[] myClasses = new Class[] {IJavaElement.class};
	
	/* (non-Javadoc)
	 * @see org.eclipse.contribution.xref.core.IXReferenceProvider#getClasses()
	 */
	public Class[] getClasses() {
		return myClasses;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.contribution.xref.core.IXReferenceProvider#getXReferences(java.lang.Object)
	 */
	public Collection getXReferences(Object o) {
		if (!(o instanceof IJavaElement)) return Collections.EMPTY_SET;
		List xrefs = new ArrayList();
		IJavaElement je = (IJavaElement)o;
		Map xrefMap = AjBatchImageBuilder.getXRefsFor(je);
		for (Iterator iter = xrefMap.keySet().iterator(); iter.hasNext();) {
			String refName = (String) iter.next();
			List handles = (List) xrefMap.get(refName);
			List associates = new ArrayList();
			for (Iterator iterator = handles.iterator();
				iterator.hasNext();
				) {
				String handle = (String)iterator.next();
				IJavaElement associate = JavaCore.create(handle);
				if (associate != null) {
					associates.add(associate);
				} else {
					System.err.println("ignoring null associate: " + handle);
				}
			}			
			XRef xref = new XRef(refName,associates);
			xrefs.add(xref);
		}
		return xrefs;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.contribution.xref.core.IXReferenceProvider#getProviderDescription()
	 */
	public String getProviderDescription() {
		return "Provides AspectJ cross-cutting structure references";
	}

	private static class XRef implements IXReference {

		private String name;
		private List associates;
		
		public XRef(String name, List associates) {
			this.name = name;
			this.associates = associates;
		}
		
		public String getName() {
			return name;
		}

		public Iterator getAssociates() {
			return associates.iterator();
		}
		
	}
	
}
