/*
 * Created on 21-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspectj.ajdt.internal.compiler.problem;

import org.aspectj.ajdt.internal.compiler.lookup.EclipseSourceLocation;
import org.aspectj.bridge.IMessage;
import org.aspectj.bridge.ISourceLocation;
import org.eclipse.core.resources.IResource;
import org.eclipse.jdt.core.ICompilationUnit;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.compiler.IProblem;
import org.eclipse.jdt.internal.compiler.problem.DefaultProblem;
import org.eclipse.jdt.internal.compiler.problem.ProblemSeverities;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class WeaverProblemAdapter {

	public static IProblem createProblemFromIMessage(IMessage message, ICompilationUnit unit) {
		int sev = ProblemSeverities.Error;
		if (message.getKind() == IMessage.WARNING) sev = ProblemSeverities.Warning;
		CharPositions pos = getCharPos(message,unit);
		IProblem p = new DefaultProblem(
							unit.getElementName().toCharArray(),
							message.getMessage(),
							IProblem.Unclassified,
							new String[0],
							sev,
							pos.start,
							pos.end,
							message.getSourceLocation().getLine()							
					     );
		return p;
	}
	
	public static IResource getTargetResourceFor(IMessage message) {
		return null;
	}
	
	
	private static CharPositions getCharPos(IMessage message,ICompilationUnit unit) {
		CharPositions pos = new CharPositions();
		ISourceLocation loc = message.getSourceLocation();
		if (loc instanceof EclipseSourceLocation) {
			EclipseSourceLocation esl = (EclipseSourceLocation) loc;
			pos.start = esl.getStartPos();
			pos.end = esl.getEndPos();
		} else {
			char[] contents;
			try {
				contents = unit.getSource().toCharArray();
				int seekToLine = message.getSourceLocation().getLine();
				int currLine = 1;
				pos.start = 0;
				while ((pos.start < contents.length) && (currLine < seekToLine)) {
					if (contents[pos.start++] == '\n') currLine++;
				}
				if (currLine == seekToLine) {
					pos.start += message.getSourceLocation().getColumn();  // currently always 0?
				}
				pos.end = pos.start + 1;
				while ((pos.end < contents.length) && !Character.isWhitespace(contents[pos.end])) {
					pos.end++;
				}
			} catch (JavaModelException e) {
				e.printStackTrace();
			}
		}
		return pos;
	}
	
	private static class CharPositions {
       public int start;
       public int end;
	}
}
