/*
 * Created on 19-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspect.ajdt.internal.core;

import org.aspectj.ajdt.core.IAspectJElement;
import org.aspectj.ajdt.core.IInterTypeMethod;
import org.aspectj.ajdt.core.jdom.IAjDOMNode;
import org.aspectj.ajdt.core.jdom.IDOMInterTypeMethod;
import org.eclipse.jdt.core.IMethod;
import org.eclipse.jdt.core.JavaModelException;
import org.eclipse.jdt.core.Signature;
import org.eclipse.jdt.core.jdom.IDOMMethod;
import org.eclipse.jdt.core.jdom.IDOMNode;
import org.eclipse.jdt.internal.core.JavaElement;
import org.eclipse.jdt.internal.core.SourceMethod;
import org.eclipse.jdt.internal.core.util.Util;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SourceInterTypeMethod extends SourceMethod implements IInterTypeMethod {
	
	/**
	 * @param parent
	 * @param name
	 * @param parameterTypes
	 */
	public SourceInterTypeMethod(JavaElement parent, String name, String[] parameterTypes) {
		super(parent, name, parameterTypes);
	}

	/* (non-Javadoc)
	 * @see org.aspectj.ajdt.core.IInterTypeMethod#getOnType()
	 */
	public String getOnType() throws JavaModelException {
		SourceInterTypeMethodElementInfo info = (SourceInterTypeMethodElementInfo) getElementInfo();
		return Signature.createTypeSignature(info.getOnType(), false);
	}
	
	

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	public boolean equals(Object o) {
		if (!(o instanceof SourceInterTypeMethod)) return false;
		return super.equals(o);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jdt.internal.core.JavaElement#equalsDOMNode(org.eclipse.jdt.core.jdom.IDOMNode)
	 */
	protected boolean equalsDOMNode(IDOMNode node) {
		if (node.getNodeType() == IAjDOMNode.ITD_METHOD) {
			try {
				IDOMInterTypeMethod m = (IDOMInterTypeMethod)node;
				if (isConstructor()) {
					return 
					(m.isConstructor() || m.getName().equals(this.getElementName()) /* case of a constructor that is being renamed */) 
					&& signatureEquals(m);
				} else {
					return super.equalsDOMNode(node) && signatureEquals(m);
				}
			} catch (JavaModelException e) {
				return false;
			}
		} else {
			return false;
		}
		
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jdt.core.IJavaElement#getElementType()
	 */
	public int getElementType() {
		return IAspectJElement.ITD_METHOD;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jdt.internal.core.JavaElement#getHandleMementoDelimiter()
	 */
	protected char getHandleMementoDelimiter() {
		return AspectJElement.AJEM_ITD_METHOD;
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jdt.internal.core.JavaElement#readableName()
	 */
	public String readableName() {
		StringBuffer buff = new StringBuffer();
		try {
			buff.append(Signature.toString(getOnType()));
			buff.append('.');
		} catch (JavaModelException ex) {}
		buff.append(super.readableName());
		return buff.toString();
	}

}
