/*
 * Created on 18-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspect.ajdt.internal.core;

import org.aspectj.ajdt.internal.compiler.env.ISourcePointcut;
import org.eclipse.jdt.core.Signature;
import org.eclipse.jdt.internal.core.MemberElementInfo;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SourcePointcutElementInfo
	extends MemberElementInfo
	implements ISourcePointcut {

	/**
	 * For a source method (that is, a method contained in a compilation unit)
	 * this is a collection of the names of the parameters for this method,
	 * in the order the parameters are delcared. For a binary method (that is, 
	 * a method declared in a binary type), these names are invented as
	 * "arg"i where i starts at 1. This is an empty array if this method
	 * has no parameters.
	 */
	protected char[][] argumentNames;

	/**
	 * Collection of type names for the arguments in this
	 * method, in the order they are declared. This is an empty
	 * array for a method with no arguments. A name is a simple
	 * name or a qualified, dot separated name.
	 * For example, Hashtable or java.util.Hashtable.
	 */
	protected char[][] argumentTypeNames;

	public char[][] getArgumentNames() {
		return this.argumentNames;
	}
	public char[][] getArgumentTypeNames() {
		return this.argumentTypeNames;
	}
	public char[] getSelector() {
		return this.name;
	}
	public String getSignature() {

		String[] paramSignatures = new String[this.argumentTypeNames.length];
		for (int i = 0; i < this.argumentTypeNames.length; ++i) {
			paramSignatures[i] = Signature.createTypeSignature(this.argumentTypeNames[i], false);
		}
		return Signature.createMethodSignature(paramSignatures, Signature.createTypeSignature(Signature.SIG_VOID, false));
	}
	public void setArgumentNames(char[][] names) {
		this.argumentNames = names;
	}
	public void setArgumentTypeNames(char[][] types) {
		this.argumentTypeNames = types;
	}
}
