/*
 * Created on 18-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspectj.ajdt.core;

import org.eclipse.jdt.core.IMember;
import org.eclipse.jdt.core.JavaModelException;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public interface IPointcut extends IMember {
	/**
	 * Returns the simple name of this method.
	 * For a constructor, this returns the simple name of the declaring type.
	 * Note: This holds whether the constructor appears in a source or binary type
	 * (even though class files internally define constructor names to be <code>"&lt;init&gt;"</code>).
	 * For the class initialization methods in binary types, this returns
	 * the special name <code>"&lt;clinit&gt;"</code>.
	 * This is a handle-only method.
	 * @return the simple name of this method
	 */
	String getElementName();
	/**
	 * Returns the number of parameters of this method.
	 * This is a handle-only method.
	 * 
	 * @return the number of parameters of this method
	 */
	int getNumberOfParameters();
	/**
	 * Returns the names of parameters in this method.
	 * For binary types, these names are invented as "arg"+i, where i starts at 1 
	 * (even if source is associated with the binary).
	 * Returns an empty array if this method has no parameters.
	 *
	 * <p>For example, a method declared as <code>public void foo(String text, int length)</code>
	 * would return the array <code>{"text","length"}</code>.
	 *
	 * @exception JavaModelException if this element does not exist or if an
	 *      exception occurs while accessing its corresponding resource.
	 * @return the names of parameters in this method, an empty array if this method has no parameters
	 */
	String[] getParameterNames() throws JavaModelException;
	/**
	 * Returns the type signatures for the parameters of this method.
	 * Returns an empty array if this method has no parameters.
	 * This is a handle-only method.
	 *
	 * <p>For example, a source method declared as <code>public void foo(String text, int length)</code>
	 * would return the array <code>{"QString;","I"}</code>.
	 * 
	 * @return the type signatures for the parameters of this method, an empty array if this method has no parameters
	 * @see Signature
	 */
	String[] getParameterTypes();
	/**
	 * Returns the signature of this pointcut. This includes the signatures for the parameter
	 * types, but does not include the pointcut name.
	 *
	 * <p>For example, a source method declared as <code>public void foo(String text, int length)</code>
	 * would return <code>"(QString;I)V"</code>.
	 *
	 * @return the signature of this method
	 * @exception JavaModelException if this element does not exist or if an
	 *      exception occurs while accessing its corresponding resource.
	 *
	 * @see Signature
	 */
	String getSignature() throws JavaModelException;
	/**
	 * Returns whether this pointcut is similar to the given pointcut.
	 * Two pointcuts are similar if:
	 * <ul>
	 * <li>their element names are equal</li>
	 * <li>they have the same number of parameters</li>
	 * <li>the simple names of their parameter types are equal</li>
	 * </ul>
	 * This is a handle-only method.
	 * 
	 * @param method the given method
	 * @return true if this method is similar to the given method.
	 * @see Signature#getSimpleName(char[])
	 * @since 2.0
	 */
	boolean isSimilar(IPointcut pointcut);	
}
