/*
 * Created on 18-Jan-2004
 *
 * To change the template for this generated file go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
package org.aspectj.ajdt.core.jdom;

import org.eclipse.jdt.core.jdom.IDOMMember;

/**
 * @author colyer
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public interface IDOMPointcut extends IDOMMember {
	/**
	 * Adds the given parameter to the end of the parameter list. 
	 * This is a convenience method for <code>setParameters</code>.
	 * The syntax for parameter names is defined by Formal Parameters (JLS2 8.4.1).
	 * The syntax for type names is defined by Formal Parameters (JLS2 8.4.1). 
	 * Type names must be specified as they would appear in source code. For
	 * example: <code>"File"</code>, <code>"java.io.File"</code>, or 
	 * <code>"int[]"</code>.
	 * 
	 * @param type the type name
	 * @param name the parameter name
	 * @exception IllegalArgumentException if <code>null</code> is specified for
	 *   either the type or the name
	 * @see #setParameters
	 */
	public void addParameter(String type, String name) throws IllegalArgumentException;
	/**
	 * Returns the body of this method. The method body includes all code following
	 * the method declaration, including the enclosing braces. 
	 *
	 * @return the body, or <code>null</code> if the method has no body (for
	 *   example, for an abstract or native method)
	 */
	public String getBody();
	/**
	 * The <code>IDOMMethod</code> refinement of this <code>IDOMNode</code>
	 * method returns the name of this method. Returns <code>null</code> for
	 * constructors. The syntax for a method  name is defined by Identifier
	 * of MethodDeclarator (JLS2 8.4).
	 */
	public String getName();
	/**
	 * Returns the names of parameters in this method in the order they are declared,
	 * or <code>null</code> if no parameters are declared.
	 * The syntax for parameter names is defined by Formal Parameters (JLS2 8.4.1).
	 * 
	 * @return the list of parameter names, or <code>null</code> if no parameters
	 *  are declared
	 */
	public String[] getParameterNames();
	/**
	 * Returns the type names for the parameters of this method in the order they are declared,
	 * or <code>null</code> if no parameters are declared.
	 * The syntax for type names is defined by Formal Parameters (JLS2 8.4.1). 
	 * Type names must be specified as they would appear in source code. For
	 * example: <code>"File"</code>, <code>"java.io.File"</code>, or 
	 * <code>"int[]"</code>.
	 * 
	 * @return the list of parameter types, or <code>null</code> if no parameters
	 *  are declared
	 */
	public String[] getParameterTypes();
	/**
	 * Sets the body of this method. The method body includes all code following
	 * the method declaration, including the enclosing braces. No formatting or
	 * syntax checking is performed on the body.
	 *
	 * @return the body, or <code>null</code> indicating the method has no body (for
	 *   example, for an abstract or native method)
	 */
	public void setBody(String body);
	/**
	 * The <code>IDOMMethod</code> refinement of this <code>IDOMNode</code>
	 * method sets the name of this method. The syntax for a method 
	 * name is defined by Identifer of MethodDeclarator (JLS2 8.4).
	 * <p>
	 * The name of a constructor is always <code>null</code> and thus it
	 * must not be set.
	 * </p>
	 *
	 * @exception IllegalArgumentException if <code>null</code> is specified
	 */
	public void setName(String name) throws IllegalArgumentException;
	/**
	 * Sets the types and names of parameters in this method in the order they are
	 * to be declared. If both <code>types</code> and <code>names</code> are <code>null</code> 
	 * this indicates that this method has no parameters.
	 * The syntax for parameter names is defined by Formal Parameters (JLS2 8.4.1).
	 * The syntax for type names is defined by Formal Parameters (JLS2 8.4.1). 
	 * Type names must be specified as they would appear in source code. For
	 * example: <code>"File"</code>, <code>"java.io.File"</code>, or 
	 * <code>"int[]"</code>.
	 * 
	 * @param types the list of type names
	 * @param names the list of parameter name
	 * @exception IllegalArgumentException if the number of types and names do not 
	 *   match, or if either argument is <code>null</code>
	 */
	public void setParameters(String[] types, String[] names) throws IllegalArgumentException;
}
